<template>
	<div class="sampling-form">
		<v-card-title class="px-0 d-flex align-start justify-space-between">
			<div>Sampling</div>
			<div class="text-body-2">
				<div v-if="location.properties.label">Location: {{ location.properties.label }}</div>
				<div v-if="location.properties.stratum">Stratum: {{ location.properties.stratum }}</div>
				<div v-if="location.properties.composite">Composite: {{ location.properties.composite }}</div>
				<div v-if="location.properties.bulkDensityRequired" class="text-body-2">Bulk Density Required</div>
			</div>
		</v-card-title>
		<v-text-field :value="timestamp" label="Timestamp" disabled />
		<div class="d-flex align-center">
			<v-text-field
				:value="`${sampling.geometry.coordinates
					.map((x) => x.toFixed(5))
					.join(', ')} (±${sampling.properties.geoAccuracy.toFixed(0)} m)`"
				label="Coordinates (lng, lat), accuracy"
				disabled
			/>
			<v-btn icon @click="$emit('updateGeolocation')">
				<v-icon>mdi-crosshairs-gps</v-icon>
			</v-btn>
		</div>
		<depths-form :items="[sampling.soDepth]" :single="true" v-if="sampling.soDepth" @setDepths="onSetSamplingDepths" />
		<v-text-field :value="sampling.comment" @input="onCommentInput" label="Comment" placeholder=" " />
		<!-- <v-divider class="mt-0 mb-4" /> -->
		<!-- TODO: add for loop to display member array (samples) -->
		<div class="text-caption">Samples</div>
		<div class="space">
			<v-chip
				v-for="sample in samples"
				:key="sample.id"
				@click="() => onSampleSelect(sample)"
				class="px-6 py-5 text-body-1 ml-2 mt-2"
				style="border-radius: 24px"
			>
				{{ sample.soDepth.minValue.value }} - {{ sample.soDepth.maxValue.value }} cm&nbsp;
				<!-- <v-icon small class="ml-1">mdi-pencil</v-icon> -->
			</v-chip>
			<!-- <v-btn
				v-for="sample in samples"
				:key="sample.id"
				@click="() => onSampleSelect(sample)"
				rounded
				color=""
			>
				{{ sample.soDepth.minValue.value }} -
				{{ sample.soDepth.maxValue.value }} cm
			</v-btn> -->
			<v-btn @click="onSampleAddClick" small fab ourlined depressed color="primary" class="ml-2 mt-2">
				<v-icon>mdi-plus</v-icon>
			</v-btn>
		</div>
		<!-- <v-list>
			<v-list-item v-for="sample in samples" :key="sample.id">
				<v-list-item-content>
					<v-list-item-title>
						{{ sample.soDepth.minValue.value }} -
						{{ sample.soDepth.maxValue.value }} cm
					</v-list-item-title>
				</v-list-item-content>
			</v-list-item>
		</v-list> -->

		<!-- <div class="d-flex justify-end">
			<v-btn
				@click="onSampleAddClick"
				class="px-4"
				rounded
				outlined
				color="primary"
			>
				Add Sample
			</v-btn>
		</div> -->
		<div class="d-flex justify-end mt-4">
			<v-btn @click="onSamplingCancel" class="px-4" text> Cancel </v-btn>
			<v-btn @click="onSamplingSave" class="px-4" rounded color="primary"> Save </v-btn>
		</div>
		<v-dialog persistent v-model="dialogIsVisible" max-width="50em">
			<v-card>
				<v-card-text>
					<sample-form
						:sample="activeSample"
						:sampling="sampling"
						:samplingCollection="samplingCollection"
						:location="location"
						@setSample="onSetSample"
						@cancelSample="dialogIsVisible = false"
						@deleteSample="onDeleteSample"
					/>
				</v-card-text>
			</v-card>
		</v-dialog>
	</div>
</template>

<script lang="ts">
import { defineComponent, ref, computed } from '@vue/composition-api';
import { Sampling, SoDepth, SamplingCollection, Sample, Location } from '@/store/types';
import DepthsForm from '@/components/forms/DepthsForm/DepthsForm.vue';
import SampleForm from '@/components/forms/SampleForm/SampleForm.vue';

export default defineComponent({
	props: {
		sampling: {
			type: Object as () => Sampling,
			required: true,
		},
		samplingCollection: {
			type: Object as () => SamplingCollection,
			required: true,
		},
		samples: {
			type: Array as () => Sample[],
		},
		location: {
			type: Object as () => Location,
		},
	},
	components: {
		DepthsForm,
		SampleForm,
	},
	setup(props, { emit }) {
		const dialogIsVisible = ref(false);
		const activeSample = ref();
		const timestamp = computed(() => new Date(props.sampling.resultTime).toLocaleString());

		function onSetSamplingDepths(depths: SoDepth[]) {
			emit('setSamplingDepth', depths[0]);
		}

		function onCommentInput(value: string) {
			emit('setSamplingComment', value);
		}

		function onSampleAddClick() {
			// Set activeSample as undefined so that SampleForm will create new sample
			activeSample.value = undefined;
			dialogIsVisible.value = true;
		}

		function onSetSample(sample: Sample) {
			emit('setSamplingResult', sample);
			dialogIsVisible.value = false;
		}

		function onSamplingCancel() {
			emit('samplingCancel');
		}

		function onSamplingSave() {
			emit('samplingSave', {
				sampling: props.sampling,
				samples: props.samples || [],
			});
		}

		function onSampleSelect(sample: Sample) {
			activeSample.value = sample;
			dialogIsVisible.value = true;
		}

		function onDeleteSample(id: string) {
			activeSample.value = undefined;
			emit('deleteSample', id);
			dialogIsVisible.value = false;
		}

		return {
			onSetSamplingDepths,
			onCommentInput,
			onSampleAddClick,
			dialogIsVisible,
			onSetSample,
			onSamplingSave,
			onSamplingCancel,
			onSampleSelect,
			activeSample,
			onDeleteSample,
			timestamp,
		};
	},
});
</script>

<style scoped>
.space:first-child {
	margin-left: 0;
}
</style>
